unit QRLIST;
{
 QuickReport simple list template
 - Connect a database table to the TTable component
 - Put QRDBText components on the Detail band and connect them to the fields
 }
interface      

uses
  wintypes,winprocs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Quickrep, StdCtrls, ExtCtrls, DB, DBTables, WPQuickR, WPDQuick, WpWinCtr,
  WPRich, Wpdbrich, Unit2;

type
  TQRListTemplate = class(TForm)
    QuickReport: TQuickReport;
    Title: TQRBand;
    PageHeader: TQRBand;
    Detail: TQRBand;
    PageNumber: TQRSysData;
    PageFooter: TQRBand;
    QRDateTime: TQRSysData;
    QRSysData1: TQRSysData;
    QRLabel1: TQRLabel;
    QRLabel3: TQRLabel;
    Table1: TTable;
    DataSource1: TDataSource;
    WPDBQuickPrint1: TWPDBQuickPrint;
    DBWPRichText1: TDBWPRichText;
    procedure QuickReportNeedData(var MoreData: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  QRListTemplate: TQRListTemplate;

implementation

{$R *.DFM}

procedure TQRListTemplate.QuickReportNeedData(var MoreData: Boolean);
var
   ThereIsNextLine : Boolean;
begin
   DBWPRichText1.Visible := FALSE;
   ThereIsNextLine := WPDBQuickPrint1.CopyNextLine( DBWPRichText1 );
   if not ThereIsNextLine then
   begin Table1.Next;
         inc(Form2.FNumber);
         Form2.Number.Caption := IntToStr(Form2.FNumber);
   end;
   MoreData := not Table1.EOF;
   if Form2.FStop and not ThereIsNextLine then MoreData := FALSE;
   if not MoreData then
   begin Form2.FClose := TRUE;
         Form2.Close;
   end;
end;

end.
