unit Qrlist2;
{
 QuickReport demo for powerfull form output.
    (RTF text will be splitted to several pages with different headers
 Some tricks were necessary to let this thing work with QuickReport 1.0.

 This Demo uses the
   WPDBQuickPrint1PrintBoxTooSmall event of TWPDBQuickPrint and
   it's property PrintFirstLine.
   The property  DoNotStretchBox has to be TRUE!
}
interface

uses
  wintypes,winprocs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Quickrep, StdCtrls, ExtCtrls, DB, DBTables, WPQuickR, WPDQuick, WpWinCtr,
  WPRich, Wpdbrich, Unit2;

type
  TQRForms = class(TForm)
    QuickReport: TQuickReport;
    DetailBand1: TQRBand;
    Table1: TTable;
    DataSource1: TDataSource;
    WPDBQuickPrint1: TWPDBQuickPrint;
    QRShape2: TQRShape;
    ContLabel: TQRLabel;
    Header: TQRBand;
    LabelOne: TQRLabel;
    LabelTwo: TQRLabel;
    procedure WPDBQuickPrint1PrintBoxTooSmall(Sender: TWPQuickPrint;
      nextline: Longint);
    procedure QuickReportNeedData(var MoreData: Boolean);
    procedure QuickReportStartPage(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FStartLine      : Longint;
    FNeedNextRecord : Boolean;
  end;

var
  QRForms: TQRForms;

implementation

{$R *.DFM}

procedure TQRForms.WPDBQuickPrint1PrintBoxTooSmall(
  Sender: TWPQuickPrint; nextline: Longint);
begin
     ContLabel.Visible := TRUE;
     FStartLine        := nextline;
     FNeedNextRecord   := FALSE;
end;

procedure TQRForms.QuickReportNeedData(var MoreData: Boolean);
begin
    if FNeedNextRecord then
    begin
       inc(Form2.FNumber);
       Form2.Number.Caption := IntToStr(Form2.FNumber);
       Table1.Next;
       FStartLine := 0;
    end;
    WPDBQuickPrint1.PrintStartLine := FStartLine;
    FStartLine      := 0;
    MoreData := not Table1.EOF;
   if Form2.FStop and FNeedNextRecord then MoreData := FALSE;
   if not MoreData then
   begin Form2.FClose := TRUE;
         Form2.Close;
   end;
   FNeedNextRecord := TRUE;
 end;

{ Note:
  with QuickReport1 it is necessary that the height
  of the DetailBand is height enough to force a page break.
      procedure TQRForms.DetailBand1AfterPrint(BandPrinted: Boolean);
      begin QuickReport.NewPage; end;
  will force a new page too, but the top position will not be correct.
     DetailBand1.Height := QuickReport.PageHeight -
       Header.Top - Header.Height - 100; will help
}

procedure TQRForms.QuickReportStartPage(Sender: TObject);
begin
    ContLabel.Visible := FALSE;
    if WPDBQuickPrint1.PrintStartLine=0 then  { print the first page }
    begin
        LabelOne.Visible     := TRUE;
        LabelTwo.Visible     := FALSE;
        Header.Height        := 53;
    end else                                 { print next pages }
    begin
        LabelTwo.Visible     := TRUE;
        LabelOne.Visible     := FALSE;
        Header.Height        := 22;
    end;
    DetailBand1.Height := QuickReport.PageHeight -
       Header.Top - Header.Height - 100;
 end;

end.
