unit WpTools;
{ WPTools V1.92 -----------------------------------------
  Version of 12/9/1996
  CopyRight 1996 by Julian Ziersch Software, Mnchen
  for Delphi 16 + 32
  INFO: http://members.aol.com/jziersch/index.html
  ------------------------------------------------------ }
interface

{$I WPINC.INC}
                  
{$IFNDEF WIN32}
  {$R WPTORES.DCR}
{$ELSE}
  {$R WPTORES.RES}
{$ENDIF}

uses Classes,  WPTBar, DsgnIntf, WPDBRich, WPRich, WPRuler, WPStatus, WPRtfIO, WPStat2,
     WPWinCtr, WPPRStt, WPPRRtf, Wpspdlg1, WPLabel, Wppagprp,
     WPParPrp, WPParBrd, WPPanel, WPPrButt
     {$IFDEF WPQUICK}, WPDQUICK, WPQUICKR {$ENDIF};
procedure Register;
implementation
procedure Register;
begin
  RegisterComponents('WPTools',
     [TWPToolBar,TWPRuler,TWPRichText,TWPRichTextLabel,
      TDBWPRichText,TWPRtfStorage,
      {$IFDEF NEEDSTATUSBAR} TWPStatusBar, {$ENDIF}
      TWPAltStatusBar,
      TWPPagePropDlg,TWPParagraphPropDlg,TWPParagraphBorderDlg,
      TWPSpellCheckDlg]);

{$IFDEF WPQUICK}
  RegisterComponents('WPTools',  [TWPQuickPrint,TWPDBQuickPrint]);
  RegisterPropertyEditor(TypeInfo(TWPRTFTextIO), TWPQuickPrint,'RtfText',TRtfTextProperty);
{$ENDIF}

  RegisterComponents('WPTools',  [TWPToolPanel,TWPComboBox,TWPToolButton]);
  RegisterPropertyEditor(TypeInfo(TWPSpeedButtonStyle), TWPToolButton,'StyleName',TWPSpeedButtonProperty);

  RegisterPropertyEditor(TypeInfo(TStringList),TWPStatusBarBasic,'Strings',TStatusItemsProperty);
  RegisterPropertyEditor(TypeInfo(TWPRTFTextIO), TWPCustomRtfEdit,'RtfText',TRtfTextProperty);
  RegisterPropertyEditor(TypeInfo(TWPRTFTextIO), TWPCustomRtfLabel,'RtfText',TRtfTextProperty);
  RegisterPropertyEditor(TypeInfo(TWPRTFTextIO), TWPRtfStorage,'RtfText',TRtfTextProperty);
  end;
end.

